// This section is for the guns recoil, As apposed to making the bullets spread around like there's no tomarrow,
// now we buttfuck their screens with some friendly recoil.

// Generates the recoil, standalone function :D
function generateRecoil(%this, %obj, %slot, %type)
{
  %vector = %obj.getMuzzleVector(%slot);
  %objectVelocity = %obj.getVelocity();
  %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
  %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
  %x = %y = %z = 0;
  %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
  %p = new(%this.projectileType)()
  {
    dataBlock = %type;
    initialVelocity = VectorAdd(%vector1,%vector2);
    initialPosition = %obj.getEyePoint();
    sourceObject = %obj;
    sourceSlot = %slot;
    client = %obj.client;
  };
}

// --------------------------------------------------------------------------------------------------------------------------

// Primary Recoil
datablock ExplosionData(weaponRecoilExplosion)
{
  lifeTimeMS = 10;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "1 1 1";
  camShakeAmp = "0.2 0.2 0.2";
  camShakeDuration = 0.6;
  camShakeRadius = 0.1;
};

//No Movement Player
datablock PlayerData(NoMoveArmor : PlayerStandardArmor)
{
	uiName = "No Movement Player";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	showEnergyBar = false;
	runForce = 1000000; // Prevents Sliding
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   jumpForce = 0; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;
};

datablock ProjectileData(weaponRecoil)
{
  uiName = "";
  explosion = weaponRecoilExplosion;
  muzzleVelocity = 0;
  velInheritFactor = 1;
  lifetime = 2;
  fadeDelay = 1;
  explodeOnDeath = true;
};

// Light Recoil
datablock ExplosionData(weaponRecoilExplosionLight : weaponRecoilExplosion)
{
  camShakeAmp = "0.1 0.1 0.1";
  camShakeDuration = 0.4;
};

datablock ProjectileData(weaponRecoilLight: weaponRecoil)
{
  explosion = weaponRecoilExplosionLight;
};

// Heavy Recoil
datablock ExplosionData(weaponRecoilExplosionHeavy : weaponRecoilExplosion)
{
  camShakeAmp = "0.5 0.5 0.5";
  camShakeDuration = 2.0;
};

datablock ProjectileData(weaponRecoilHeavy: weaponRecoil)
{
  explosion = weaponRecoilExplosionHeavy;
};

package CoolStuffFires
{
// Here we have the spread scripts and ammo scripts, enjoy the fun on a bun here in the sun.
function WeaponImage::onFire(%this,%obj,%slot)
{
	%client = %obj.client;
	%im = %obj.getMountedImage(0);

	if(%im.item.isRyWeapon != 1 || %obj.getClassName() $= AiPlayer)
	{
		return Parent::onFire(%this,%obj,%slot);
	}
	else
	{
		%this.raycastDirectDamage = %this.baseDamage;
	}
	
	if(%client.quantity[%im.item.ammoType] > 0 || %obj.toolAmmo[%obj.currTool] > 0)
	{
		// Recoil Gen
		if(%im.recoilType $= "Heavy")
			generateRecoil(%this, %obj, %slot, "weaponRecoilHeavy");
		else if (%im.recoilType $= "Light")
			generateLightRecoil(%this, %obj, %slot, "weaponRecoilLight");
		else
			generateRecoil(%this, %obj, %slot, "weaponRecoil");
			
		// Fire Anim
		if(%im.fireAnim $= "Plant")
			%obj.playThread(2, plant);
		else if(%im.fireAnim $= "ShiftAway")
			%obj.playThread(2, shiftAway);
		else if(%im.fireAnim $= "Activate")
			%obj.playThread(2, activate);
			
		// Spread Gen
		if(%obj.lastFireTime + %im.recoilRemoveDelay > getSimTime())
		{
			%im.raycastSpreadAmt += %im.recoilAddRate;
		}
		else
		{
			//if (%this.raycastSpreadAmt <= %this.defaultSpreadAmt)
				%im.raycastSpreadAmt = %im.defaultSpreadAmt;
			//else
			//{
				//%numOfRecoilPeriods = 1;
				//for(%val = (%obj.lastFireTime + %im.recoilRemoveDelay); (%val + %im.recoilRemoveDelay) <= getSimTime(); %val += %im.recoilRemoveDelay) 
				//	%numOfReocilPeriods++;
				
				//%this.raycastSpreadAmt -= (%im.reocilSubRate * %numOfRecoilPeriods);
			//}
		}
		
		if(vectorLen(%obj.getVelocity()) > 0.1)
			%im.raycastSpreadAmt = (%im.raycastSpreadAmt * %im.recoilMovementRate);
		
		if(%im.raycastSpreadAmt >= %im.maxRecoil)
			%im.raycastSpreadAmt = %im.maxRecoil;
			
		// Bipod Support
		if(%im.usesBiPod == 1 && %obj.isBipodDeployed == 1)
			%im.raycastSpreadAmt = (%im.raycastSpreadAmt / %im.biPodRecoilReduct);
	
		// And all the other little giggles in-between
		%obj.toolAmmo[%obj.currTool]--;
		displayAmmo(%obj.client, %obj, %im);
		%obj.lastFireTime = getSimTime();
		Parent::onFire(%im,%obj,%slot);
	}
	else if(%obj.getClassName() $= Player)
		%obj.unMountImage(%slot);
}		
function WeaponImage::ReloadComplete(%this, %obj, %slot)
{
	%im = %obj.getMountedImage(0);
	%ammoUsed = %im.Item.maxAmmo - %obj.toolAmmo[%obj.currTool]; 

	if(%obj.client.quantity[%im.item.ammoType] >= 1)
    {
		if(%ammoUsed > %obj.client.quantity[%im.item.ammoType])
		{
			%obj.toolAmmo[%obj.currTool] += %obj.client.quantity[%im.item.ammoType];
			%obj.client.quantity[%im.item.ammoType] = 0;	
		}
		else
		{
			%obj.toolAmmo[%obj.currTool] += %ammoUsed;
			%obj.client.quantity[%im.item.ammoType] -= %ammoUsed;
		}
		%obj.setImageAmmo(%slot,1);
		if(%obj.client.quantity[%im.item.ammoType] <= 0)
			%obj.client.quantity[%im.item.ammoType] = 0;
		displayAmmo(%obj.client, %obj, %im);
		return;
    }
}

function Armor::onTrigger(%this, %player, %slot, %val)
{
    if(%player.getMountedImage(0).usesBiPod == 1 && %player.getDatablock().usesTacKnife != 1 && %slot $= 4 && %val)
    {
		if(%player.isBipodDeployed == 1)
		{
			%player.playsound(BiPodDequipSound);
			%player.popDatablock(NoMoveArmor.getID());
			%player.playThread(2, plant);
			%player.isBipodDeployed = 0;
		}
		else
		{
			%player.playsound(BiPodEquipSound);
			%player.pushDatablock(NoMoveArmor.getID());
			%player.playThread(2, shiftleft);
			%player.isBipodDeployed = 1;
			%player.setVelocity(0);
		}
    }
    Parent::onTrigger(%this, %player, %slot, %val);
}

function WeaponImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
	%im = %obj.getMountedImage(0);
	if(%col.getType() & $TypeMasks::PlayerObjectType && %im.Item.isRyWeapon)
   {
      %colscale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale && %obj.getClassName() $= Player)
		%this.raycastDirectDamage = (%this.raycastDirectDamage * %im.nodeDamageMultiHead);
   }
	Parent::OnRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
}
};
activatePackage(CoolStuffFires);